package javax.naming.directory;

import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.Name;
import javax.naming.Context;

public interface DirContext extends Context
{
    public static final int ADD_ATTRIBUTE = 1;
    public static final int REPLACE_ATTRIBUTE = 2;
    public static final int REMOVE_ATTRIBUTE = 3;
    
    public abstract Attributes getAttributes(Name p0) throws NamingException;
    
    public abstract Attributes getAttributes(String p0) throws NamingException;
    
    public abstract Attributes getAttributes(Name p0, String[] p1) throws NamingException;
    
    public abstract Attributes getAttributes(String p0, String[] p1) throws NamingException;
    
    public abstract void modifyAttributes(Name p0, int p1, Attributes p2) throws NamingException;
    
    public abstract void modifyAttributes(String p0, int p1, Attributes p2) throws NamingException;
    
    public abstract void modifyAttributes(Name p0, ModificationItem[] p1) throws NamingException;
    
    public abstract void modifyAttributes(String p0, ModificationItem[] p1) throws NamingException;
    
    public abstract void bind(Name p0, Object p1, Attributes p2) throws NamingException;
    
    public abstract void bind(String p0, Object p1, Attributes p2) throws NamingException;
    
    public abstract void rebind(Name p0, Object p1, Attributes p2) throws NamingException;
    
    public abstract void rebind(String p0, Object p1, Attributes p2) throws NamingException;
    
    public abstract DirContext createSubcontext(Name p0, Attributes p1) throws NamingException;
    
    public abstract DirContext createSubcontext(String p0, Attributes p1) throws NamingException;
    
    public abstract DirContext getSchema(Name p0) throws NamingException;
    
    public abstract DirContext getSchema(String p0) throws NamingException;
    
    public abstract DirContext getSchemaClassDefinition(Name p0) throws NamingException;
    
    public abstract DirContext getSchemaClassDefinition(String p0) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(Name p0, Attributes p1, String[] p2) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(String p0, Attributes p1, String[] p2) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(Name p0, Attributes p1) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(String p0, Attributes p1) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(Name p0, String p1, SearchControls p2) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(String p0, String p1, SearchControls p2) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(Name p0, String p1, Object[] p2, SearchControls p3) throws NamingException;
    
    public abstract NamingEnumeration<SearchResult> search(String p0, String p1, Object[] p2, SearchControls p3) throws NamingException;
}
